#ifndef __DBUS_PROXY_CONEXUS_DBUS_TTY_H
#define __DBUS_PROXY_CONEXUS_DBUS_TTY_H

#include <dbus-cxx.h>

#include <conexus/tty.h>

#include <conexus-dbus/serial_proxy.h>

#include <conexus/tty_interface.h>
#ifndef __DBUS_CONEXUS__FLOWCONTROL_ITERATOR_SUPPORT
  #define __DBUS_CONEXUS__FLOWCONTROL_ITERATOR_SUPPORT
  DBUS_CXX_ITERATOR_SUPPORT( Conexus::FlowControl , int32_t )
#endif

#ifndef __DBUS_CONEXUS__PARITY_ITERATOR_SUPPORT
  #define __DBUS_CONEXUS__PARITY_ITERATOR_SUPPORT
  DBUS_CXX_ITERATOR_SUPPORT( Conexus::Parity , int32_t )
#endif

#ifndef __DBUS_CONEXUS__PARITYERROR_ITERATOR_SUPPORT
  #define __DBUS_CONEXUS__PARITYERROR_ITERATOR_SUPPORT
  DBUS_CXX_ITERATOR_SUPPORT( Conexus::ParityError , int32_t )
#endif

#ifndef __DBUS_CONEXUS__READWRITE_ITERATOR_SUPPORT
  #define __DBUS_CONEXUS__READWRITE_ITERATOR_SUPPORT
  DBUS_CXX_ITERATOR_SUPPORT( Conexus::ReadWrite , int32_t )
#endif

#ifndef __DBUS_CONEXUS__SETOPTION_ITERATOR_SUPPORT
  #define __DBUS_CONEXUS__SETOPTION_ITERATOR_SUPPORT
  DBUS_CXX_ITERATOR_SUPPORT( Conexus::SetOption , int32_t )
#endif


namespace Conexus {
  namespace DBus {

    class TTYProxy : public SerialProxy, public virtual TTYInterface
    {
      protected:
        TTYProxy( ::DBus::Connection::pointer conn, const std::string& dest="Conexus.TTY", const std::string& path="/Conexus/TTY"):
          SerialProxy(conn, dest, path)
        {
          ::DBus::Path child_path;

          m_method_drain_v = this->create_method< void >( "Conexus.TTY", "drain" );
          m_method_flush_input_v = this->create_method< void >( "Conexus.TTY", "flush_input" );
          m_method_flush_output_v = this->create_method< void >( "Conexus.TTY", "flush_output" );
          m_method_flush_v = this->create_method< void >( "Conexus.TTY", "flush" );
          m_method_suspend_output_v = this->create_method< void >( "Conexus.TTY", "suspend_output" );
          m_method_restart_output_v = this->create_method< void >( "Conexus.TTY", "restart_output" );
          m_method_suspend_input_v = this->create_method< void >( "Conexus.TTY", "suspend_input" );
          m_method_restart_input_v = this->create_method< void >( "Conexus.TTY", "restart_input" );
          m_method_set_input_speed_vui = this->create_method< void,uint32_t,Conexus::SetOption >( "Conexus.TTY", "set_input_speed" );
          m_method_set_output_speed_vui = this->create_method< void,uint32_t,Conexus::SetOption >( "Conexus.TTY", "set_output_speed" );
          m_method_set_speed_vui = this->create_method< void,uint32_t,Conexus::SetOption >( "Conexus.TTY", "set_speed" );
          m_method_input_speed_u = this->create_method< uint32_t >( "Conexus.TTY", "input_speed" );
          m_method_output_speed_u = this->create_method< uint32_t >( "Conexus.TTY", "output_speed" );
          m_method_parity_i = this->create_method< Conexus::Parity >( "Conexus.TTY", "parity" );
          m_method_set_parity_vi = this->create_method< void,Conexus::Parity >( "Conexus.TTY", "set_parity" );
          m_method_set_parity_viii = this->create_method< void,Conexus::Parity,Conexus::ParityError,Conexus::SetOption >( "Conexus.TTY", "set_parity" );
          m_method_parity_error_i = this->create_method< Conexus::ParityError >( "Conexus.TTY", "parity_error" );
          m_method_byte_size_u = this->create_method< uint32_t >( "Conexus.TTY", "byte_size" );
          m_method_set_byte_size_vui = this->create_method< void,uint32_t,Conexus::SetOption >( "Conexus.TTY", "set_byte_size" );
          m_method_stop_bits_u = this->create_method< uint32_t >( "Conexus.TTY", "stop_bits" );
          m_method_set_stop_bits_vui = this->create_method< void,uint32_t,Conexus::SetOption >( "Conexus.TTY", "set_stop_bits" );
          m_method_flow_control_i = this->create_method< Conexus::FlowControl >( "Conexus.TTY", "flow_control" );
          m_method_set_flow_control_vii = this->create_method< void,Conexus::FlowControl,Conexus::SetOption >( "Conexus.TTY", "set_flow_control" );
          m_method_is_carrier_detect_enabled_b = this->create_method< bool >( "Conexus.TTY", "is_carrier_detect_enabled" );
          m_method_enable_carrier_detect_vbi = this->create_method< void,bool,Conexus::SetOption >( "Conexus.TTY", "enable_carrier_detect" );
          m_method_is_receiver_enabled_b = this->create_method< bool >( "Conexus.TTY", "is_receiver_enabled" );
          m_method_enable_receiver_vbi = this->create_method< void,bool,Conexus::SetOption >( "Conexus.TTY", "enable_receiver" );
          m_method_open_v = this->create_method< void >( "Conexus.TTY", "open" );
          m_method_open_vsi = this->create_method< void,const std::string&,Conexus::ReadWrite >( "Conexus.TTY", "open" );
          m_method_close_vb = this->create_method< void,bool >( "Conexus.TTY", "close" );
          m_method_inject_vy = this->create_method< void,uint8_t >( "Conexus.TTY", "inject" );
          m_method_inject_vs = this->create_method< void,const std::string& >( "Conexus.TTY", "inject" );
          m_method_is_reset_on_close_enabled_b = this->create_method< bool >( "Conexus.TTY", "is_reset_on_close_enabled" );
          m_method_enable_reset_on_close_vb = this->create_method< void,bool >( "Conexus.TTY", "enable_reset_on_close" );
          m_signal_input_speed_changed = this->create_signal<void>( "Conexus.TTY", "input_speed_changed" );
          m_signal_output_speed_changed = this->create_signal<void>( "Conexus.TTY", "output_speed_changed" );
          m_signal_parity_changed = this->create_signal<void>( "Conexus.TTY", "parity_changed" );
          m_signal_byte_size_changed = this->create_signal<void>( "Conexus.TTY", "byte_size_changed" );
          m_signal_stop_bits_changed = this->create_signal<void>( "Conexus.TTY", "stop_bits_changed" );
          m_signal_flow_control_changed = this->create_signal<void>( "Conexus.TTY", "flow_control_changed" );
          m_signal_carrier_detect_changed = this->create_signal<void>( "Conexus.TTY", "carrier_detect_changed" );
          m_signal_receiver_changed = this->create_signal<void>( "Conexus.TTY", "receiver_changed" );
        }

      public:

        typedef DBusCxxPointer<TTYProxy> pointer;

        static pointer create( ::DBus::Connection::pointer conn,
                               const std::string& dest="Conexus.TTY",
                               const std::string& path="/Conexus/TTY"
                             )
        { return pointer( new TTYProxy(conn, dest, path)); }


        virtual void drain( ) { return (*m_method_drain_v)(); }

        virtual void flush_input( ) { return (*m_method_flush_input_v)(); }

        virtual void flush_output( ) { return (*m_method_flush_output_v)(); }

        virtual void flush( ) { return (*m_method_flush_v)(); }

        virtual void suspend_output( ) { return (*m_method_suspend_output_v)(); }

        virtual void restart_output( ) { return (*m_method_restart_output_v)(); }

        virtual void suspend_input( ) { return (*m_method_suspend_input_v)(); }

        virtual void restart_input( ) { return (*m_method_restart_input_v)(); }

        virtual void set_input_speed( uint32_t speed, Conexus::SetOption set_option ) { return (*m_method_set_input_speed_vui)( speed, set_option); }

        virtual void set_output_speed( uint32_t speed, Conexus::SetOption set_option ) { return (*m_method_set_output_speed_vui)( speed, set_option); }

        virtual void set_speed( uint32_t speed, Conexus::SetOption set_option ) { return (*m_method_set_speed_vui)( speed, set_option); }

        virtual uint32_t input_speed( ) { return (*m_method_input_speed_u)(); }

        virtual uint32_t output_speed( ) { return (*m_method_output_speed_u)(); }

        virtual Conexus::Parity parity( ) { return (*m_method_parity_i)(); }

        virtual void set_parity( Conexus::Parity mode ) { return (*m_method_set_parity_vi)( mode); }

        virtual void set_parity( Conexus::Parity mode, Conexus::ParityError error_mode, Conexus::SetOption set_option ) { return (*m_method_set_parity_viii)( mode, error_mode, set_option); }

        virtual Conexus::ParityError parity_error( ) { return (*m_method_parity_error_i)(); }

        virtual uint32_t byte_size( ) { return (*m_method_byte_size_u)(); }

        virtual void set_byte_size( uint32_t size, Conexus::SetOption set_option ) { return (*m_method_set_byte_size_vui)( size, set_option); }

        virtual uint32_t stop_bits( ) { return (*m_method_stop_bits_u)(); }

        virtual void set_stop_bits( uint32_t size, Conexus::SetOption set_option ) { return (*m_method_set_stop_bits_vui)( size, set_option); }

        virtual Conexus::FlowControl flow_control( ) { return (*m_method_flow_control_i)(); }

        virtual void set_flow_control( Conexus::FlowControl mode, Conexus::SetOption set_option ) { return (*m_method_set_flow_control_vii)( mode, set_option); }

        virtual bool is_carrier_detect_enabled( ) { return (*m_method_is_carrier_detect_enabled_b)(); }

        virtual void enable_carrier_detect( bool enable, Conexus::SetOption set_option ) { return (*m_method_enable_carrier_detect_vbi)( enable, set_option); }

        virtual bool is_receiver_enabled( ) { return (*m_method_is_receiver_enabled_b)(); }

        virtual void enable_receiver( bool enable, Conexus::SetOption set_option ) { return (*m_method_enable_receiver_vbi)( enable, set_option); }

        virtual void open( ) { return (*m_method_open_v)(); }

        virtual void open( const std::string& name, Conexus::ReadWrite mode ) { return (*m_method_open_vsi)( name, mode); }

        virtual void close( bool force ) { return (*m_method_close_vb)( force); }

        virtual void inject( uint8_t data ) { return (*m_method_inject_vy)( data); }

        virtual void inject( const std::string& buffer ) { return (*m_method_inject_vs)( buffer); }

        virtual bool is_reset_on_close_enabled( ) { return (*m_method_is_reset_on_close_enabled_b)(); }

        virtual void enable_reset_on_close( bool reset ) { return (*m_method_enable_reset_on_close_vb)( reset); }

        ::DBus::signal_proxy<void >& signal_input_speed_changed() { return *m_signal_input_speed_changed; }

        ::DBus::signal_proxy<void >& signal_output_speed_changed() { return *m_signal_output_speed_changed; }

        ::DBus::signal_proxy<void >& signal_parity_changed() { return *m_signal_parity_changed; }

        ::DBus::signal_proxy<void >& signal_byte_size_changed() { return *m_signal_byte_size_changed; }

        ::DBus::signal_proxy<void >& signal_stop_bits_changed() { return *m_signal_stop_bits_changed; }

        ::DBus::signal_proxy<void >& signal_flow_control_changed() { return *m_signal_flow_control_changed; }

        ::DBus::signal_proxy<void >& signal_carrier_detect_changed() { return *m_signal_carrier_detect_changed; }

        ::DBus::signal_proxy<void >& signal_receiver_changed() { return *m_signal_receiver_changed; }


      protected:


        ::DBus::MethodProxy<void>::pointer m_method_drain_v;
        ::DBus::MethodProxy<void>::pointer m_method_flush_input_v;
        ::DBus::MethodProxy<void>::pointer m_method_flush_output_v;
        ::DBus::MethodProxy<void>::pointer m_method_flush_v;
        ::DBus::MethodProxy<void>::pointer m_method_suspend_output_v;
        ::DBus::MethodProxy<void>::pointer m_method_restart_output_v;
        ::DBus::MethodProxy<void>::pointer m_method_suspend_input_v;
        ::DBus::MethodProxy<void>::pointer m_method_restart_input_v;
        ::DBus::MethodProxy<void,uint32_t,Conexus::SetOption>::pointer m_method_set_input_speed_vui;
        ::DBus::MethodProxy<void,uint32_t,Conexus::SetOption>::pointer m_method_set_output_speed_vui;
        ::DBus::MethodProxy<void,uint32_t,Conexus::SetOption>::pointer m_method_set_speed_vui;
        ::DBus::MethodProxy<uint32_t>::pointer m_method_input_speed_u;
        ::DBus::MethodProxy<uint32_t>::pointer m_method_output_speed_u;
        ::DBus::MethodProxy<Conexus::Parity>::pointer m_method_parity_i;
        ::DBus::MethodProxy<void,Conexus::Parity>::pointer m_method_set_parity_vi;
        ::DBus::MethodProxy<void,Conexus::Parity,Conexus::ParityError,Conexus::SetOption>::pointer m_method_set_parity_viii;
        ::DBus::MethodProxy<Conexus::ParityError>::pointer m_method_parity_error_i;
        ::DBus::MethodProxy<uint32_t>::pointer m_method_byte_size_u;
        ::DBus::MethodProxy<void,uint32_t,Conexus::SetOption>::pointer m_method_set_byte_size_vui;
        ::DBus::MethodProxy<uint32_t>::pointer m_method_stop_bits_u;
        ::DBus::MethodProxy<void,uint32_t,Conexus::SetOption>::pointer m_method_set_stop_bits_vui;
        ::DBus::MethodProxy<Conexus::FlowControl>::pointer m_method_flow_control_i;
        ::DBus::MethodProxy<void,Conexus::FlowControl,Conexus::SetOption>::pointer m_method_set_flow_control_vii;
        ::DBus::MethodProxy<bool>::pointer m_method_is_carrier_detect_enabled_b;
        ::DBus::MethodProxy<void,bool,Conexus::SetOption>::pointer m_method_enable_carrier_detect_vbi;
        ::DBus::MethodProxy<bool>::pointer m_method_is_receiver_enabled_b;
        ::DBus::MethodProxy<void,bool,Conexus::SetOption>::pointer m_method_enable_receiver_vbi;
        ::DBus::MethodProxy<void>::pointer m_method_open_v;
        ::DBus::MethodProxy<void,const std::string&,Conexus::ReadWrite>::pointer m_method_open_vsi;
        ::DBus::MethodProxy<void,bool>::pointer m_method_close_vb;
        ::DBus::MethodProxy<void,uint8_t>::pointer m_method_inject_vy;
        ::DBus::MethodProxy<void,const std::string&>::pointer m_method_inject_vs;
        ::DBus::MethodProxy<bool>::pointer m_method_is_reset_on_close_enabled_b;
        ::DBus::MethodProxy<void,bool>::pointer m_method_enable_reset_on_close_vb;
        ::DBus::signal_proxy<void>::pointer m_signal_input_speed_changed;
        ::DBus::signal_proxy<void>::pointer m_signal_output_speed_changed;
        ::DBus::signal_proxy<void>::pointer m_signal_parity_changed;
        ::DBus::signal_proxy<void>::pointer m_signal_byte_size_changed;
        ::DBus::signal_proxy<void>::pointer m_signal_stop_bits_changed;
        ::DBus::signal_proxy<void>::pointer m_signal_flow_control_changed;
        ::DBus::signal_proxy<void>::pointer m_signal_carrier_detect_changed;
        ::DBus::signal_proxy<void>::pointer m_signal_receiver_changed;


    };

  }
}

#endif
